<html>
<!--

  Arkanon <arkanon@klsd.org.br>
  2018/10/19 (Fri) 21:09:20 -03

-->
<head>
  <meta charset="utf-8">
  <script>

    var body, marginTop, marginRight, marginBottom, marginLeft;
    var canvas, canvas_id, context, dataset, mainloop, row, col, N, M, m, Cr, Ci, ins;
    var mandelcor, sqmodlim, Z0, W, H, I, S, O, L, R;

    function rq (x) { return Math.sqrt (x) }
    function sen(x) { return Math.sin  (x) }
    function cos(x) { return Math.cos  (x) }
    function tg (x) { return sen(x)/cos(x) }

    var fi = (rq(5)+1)/2;
    var pi = 4*Math.atan(1);

    window.onload = function()
    {

      mandelcor = [0, 0, 0];
       sqmodlim =  4;

         // Z0 = [ fi-2.2 , 0    ];
         // Z0 = [ fi-2.2 , fi-1 ];
         // Z0 = [ 0.285  , 0    ];
         // Z0 = [ 0.285  , 0.01 ];
         // Z0 = [ -pi/fi , 0    ]; s=0.0506; L = [ -s , -s ]; R = [ s , s ];
            Z0 = [ -0.824 , 0    ]; s=2.0000; L = [ -s , -s ]; R = [ s , s ];

      canvas_id    = 'plano';

      body         = document.getElementsByTagName('body')[0];
      marginTop    = computed('margin-top'   );
      marginRight  = computed('margin-right' );
      marginBottom = computed('margin-bottom');
      marginLeft   = computed('margin-left'  );

      I = 300;
   // O = [  0 ,  0 ];

   // S = 1;
   // W = 500;
   // H = 500;

   // W = window.innerWidth  - ( marginLeft + marginRight  );
      H = window.innerHeight - ( marginTop  + marginBottom );
   // S = 2 * Math.sqrt(sqmodlim) / (H>W?W:H);
   // L = [ O[0] - S*W/2 , O[1] - S*H/2 ];
   // R = [ O[0] + S*W/2 , O[1] + S*H/2 ];

      if ( H === undefined )
      {
        S = (R[0]-L[0])/W;
        H = W*(R[1]-L[1])/(R[0]-L[0]);
      }
      else
      {
        S = (R[0]-L[0])/H;
        W = H*(R[1]-L[1])/(R[0]-L[0]);
      }

      canvas        = document.getElementById(canvas_id);
      canvas.width  = W;
      canvas.height = H;
      context       =  canvas.getContext('2d');
      dataset       = context.getImageData(0, 0, W, H);

      row = 0;
      Ci  = R[1];
      mainloop = setInterval
      (
        function()
        {
          var cor;
          col = 0;
          for (Cr=L[0]; Cr<=R[0]; Cr+=S)
          {
            cor = mandelcor;
            ins = inSet(Cr, Ci, I, sqmodlim);
              M = Math.sqrt(ins[1]);
              m = Math.sqrt(ins[2]);
              N =           ins[3];
            if (!ins[0]) cor = [ 10*N/m , 40*N/m , 40*m ];
            plotpix(row, col, cor);
            col++;
          }
          Ci -= S;
          row++;
          context.putImageData(dataset, 0, 0);
          if ( Ci<L[1] ) clearInterval(mainloop);
        }
      , 1 )

    }

    function  inSet(Cr, Ci, I, sqmodlim)
    {
      var tmp, znr, zni, znm2, n;
      znr = Z0[0];
      zni = Z0[1];
      for (n=1; n<=I; n++)
      {
         tmp = 2*Cr*Ci         + zni;
          Cr =   Cr*Cr - Ci*Ci + znr;
          Ci = tmp;
        znm2 = znr * znr + zni * zni;
         cm2 =  Cr *  Cr +  Ci *  Ci;
        if (cm2 >= sqmodlim) return [false, znm2, cm2, n];
      }
      return [true, znm2, cm2];
    }



    function plotpix(row, col, cor)
    {
      var i = ( row * W + col )*4;
      dataset.data[i+0] = cor[0];
      dataset.data[i+1] = cor[1];
      dataset.data[i+2] = cor[2];
      dataset.data[i+3] = 255;
    }



    function computed(prop)
    {
      return parseFloat(window.getComputedStyle(body).getPropertyValue(prop));
    }



  </script>
  <style>
    body
    {
      margin: 0;
    }
    #icon
    {
      vertical-align: middle;
      padding: 2px;
      border: 1px solid black;
    }
  </style>
</head>
<body><canvas id="plano"></canvas></body>
</html>
